/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO
 *
 */

package de.ivu.elect.business.wahlvorschlagsperson.boundary;

import de.ivu.elect.business.wahlvorschlagsperson.entity.WahlvorschlagsPerson;

@javax.enterprise.context.ApplicationScoped // ELECT-7845
public class WahlvorschlagsPersonDAO extends AbstractWahlvorschlagsPersonDAO {

  private static final long serialVersionUID = 1L;

  @javax.inject.Inject
  private transient de.ivu.elect.jee.entity.SimpleDAO simpleDAO;

  @Override
  protected javax.persistence.EntityManager getEntityManager() {
    return simpleDAO.getEntityManager();
  }

  public void persist(WahlvorschlagsPerson wahlvorschlagsPerson){
    getEntityManager().persist(wahlvorschlagsPerson);
  }

  public void remove(WahlvorschlagsPerson wahlvorschlagsPerson){
    getEntityManager().remove(wahlvorschlagsPerson);
  }

@javax.inject.Inject
private transient de.ivu.elect.presentation.system.DAOCache daoCache;

                                                                                                                            
        /**
        * Name: TypAndWahlAndOrdnungsmerkmalNoFlush<br>
        * Beschreibung: <br>
        * EJBQL: SELECT obj FROM WahlvorschlagsPerson obj WHERE obj.wahlvorschlagsPersonTyp = ?1 AND obj.wahl = ?2 AND obj.externesOrdnungsmerkmal = ?3<br>
        * SQL: <br>
        */
        @Override
        public java.util.List<WahlvorschlagsPerson> findByTypAndWahlAndOrdnungsmerkmal( @javax.annotation.Nonnull de.ivu.elect.business.wahlvorschlagsperson.entity.WahlvorschlagsPersonTyp typ,  @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl,  @javax.annotation.Nonnull java.lang.String externesOrdnungsmerkmal) {

        if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
        de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("WahlvorschlagsPerson.findByTypAndWahlAndOrdnungsmerkmal" ,  typ ,  wahl ,  externesOrdnungsmerkmal  );

        Object cached = daoCache.findInCache(key);

        if (cached==null) {
          return daoCache.cache(key, super.findByTypAndWahlAndOrdnungsmerkmal( typ ,  wahl ,  externesOrdnungsmerkmal  ));
        }
        return (java.util.List<WahlvorschlagsPerson>) cached;
        }
            return super.findByTypAndWahlAndOrdnungsmerkmal( typ ,  wahl ,  externesOrdnungsmerkmal  );
            }
                                        
        /**
        * Name: WahlOhneUnterstuetzerNoFlush<br>
        * Beschreibung: <br>
        * EJBQL: select wp from WahlvorschlagsPerson wp where wp.wahl = ?1 and wp.wahlvorschlagsPersonTyp != de.ivu.elect.business.wahlvorschlagsperson.entity.WahlvorschlagsPersonTyp.UNTERSTUETZER<br>
        * SQL: <br>
        */
        @Override
        public java.util.List<WahlvorschlagsPerson> findByWahlOhneUnterstuetzer( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl) {

        if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
        de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("WahlvorschlagsPerson.findByWahlOhneUnterstuetzer" ,  wahl  );

        Object cached = daoCache.findInCache(key);

        if (cached==null) {
          return daoCache.cache(key, super.findByWahlOhneUnterstuetzer( wahl  ));
        }
        return (java.util.List<WahlvorschlagsPerson>) cached;
        }
            return super.findByWahlOhneUnterstuetzer( wahl  );
            }
                                            
        /**
        * Name: WahlvorschlagAndStatusOhneUnterstuetzerNoFlush<br>
        * Beschreibung: <br>
        * EJBQL: select wp from WahlvorschlagsPerson wp where wp.wahlvorschlag = ?1 and wp.wahlvorschlagsPersonTyp != de.ivu.elect.business.wahlvorschlagsperson.entity.WahlvorschlagsPersonTyp.UNTERSTUETZER and wp.personStatus = ?2<br>
        * SQL: <br>
        */
        @Override
        public java.util.List<WahlvorschlagsPerson> findByWahlvorschlagAndStatusOhneUnterstuetzer( @javax.annotation.Nonnull de.ivu.elect.business.wahlvorschlag.entity.Wahlvorschlag wahlvorschlag,  @javax.annotation.Nonnull de.ivu.elect.business.person.entity.PersonStatus personStatus) {

        if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
        de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("WahlvorschlagsPerson.findByWahlvorschlagAndStatusOhneUnterstuetzer" ,  wahlvorschlag ,  personStatus  );

        Object cached = daoCache.findInCache(key);

        if (cached==null) {
          return daoCache.cache(key, super.findByWahlvorschlagAndStatusOhneUnterstuetzer( wahlvorschlag ,  personStatus  ));
        }
        return (java.util.List<WahlvorschlagsPerson>) cached;
        }
            return super.findByWahlvorschlagAndStatusOhneUnterstuetzer( wahlvorschlag ,  personStatus  );
            }
                                        
        /**
        * Name: WahlvorschlagNoFlush<br>
        * Beschreibung: <br>
        * EJBQL: select wp from WahlvorschlagsPerson wp where wp.wahlvorschlag = ?1<br>
        * SQL: <br>
        */
        @Override
        public java.util.List<WahlvorschlagsPerson> findByWahlvorschlag( @javax.annotation.Nonnull de.ivu.elect.business.wahlvorschlag.entity.Wahlvorschlag wahlvorschlag) {

        if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
        de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("WahlvorschlagsPerson.findByWahlvorschlag" ,  wahlvorschlag  );

        Object cached = daoCache.findInCache(key);

        if (cached==null) {
          return daoCache.cache(key, super.findByWahlvorschlag( wahlvorschlag  ));
        }
        return (java.util.List<WahlvorschlagsPerson>) cached;
        }
            return super.findByWahlvorschlag( wahlvorschlag  );
            }
                                        
        /**
        * Name: WahlvorschlagOhneUnterstuetzerNoFlush<br>
        * Beschreibung: <br>
        * EJBQL: select wp from WahlvorschlagsPerson wp where wp.wahlvorschlag = ?1 and wp.wahlvorschlagsPersonTyp != de.ivu.elect.business.wahlvorschlagsperson.entity.WahlvorschlagsPersonTyp.UNTERSTUETZER<br>
        * SQL: <br>
        */
        @Override
        public java.util.List<WahlvorschlagsPerson> findByWahlvorschlagOhneUnterstuetzer( @javax.annotation.Nonnull de.ivu.elect.business.wahlvorschlag.entity.Wahlvorschlag wahlvorschlag) {

        if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
        de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("WahlvorschlagsPerson.findByWahlvorschlagOhneUnterstuetzer" ,  wahlvorschlag  );

        Object cached = daoCache.findInCache(key);

        if (cached==null) {
          return daoCache.cache(key, super.findByWahlvorschlagOhneUnterstuetzer( wahlvorschlag  ));
        }
        return (java.util.List<WahlvorschlagsPerson>) cached;
        }
            return super.findByWahlvorschlagOhneUnterstuetzer( wahlvorschlag  );
            }
                    
@Override
public void clear() {
super.clear();
if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
daoCache.clear();
}

}

@Override
public void flush() {
super.flush();
if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
daoCache.clear();
}
}



}